
#define DEBUG false
 


#include <Servo.h> 
Servo servoBase1;  // create servo object to control a servo 
Servo servoBase2;  // create servo object to control a servo 
int pre_pos = 90;
int pos = 90;
int serAng=90;

void setup()
{
  Serial1.begin(9600);  
  
  //pinMode(13,OUTPUT);
  //digitalWrite(13,LOW);
   
  sendData("AT+RST\r\n",500,DEBUG); // reset module
  sendData("AT+CWMODE=2\r\n",500,DEBUG); // configure as access point
  sendData("AT+CIFSR\r\n",500,DEBUG); // get ip address
  sendData("AT+CIPMUX=1\r\n",500,DEBUG); // configure for multiple connections
  sendData("AT+CIPSERVER=1,80\r\n",500,DEBUG); // turn on server on port 80
  
           delay(1000);

  servoBase1.attach(A6);
  servoBase2.attach(A7);
           delay(100);
         
 servoBase1.write(90); 
 servoBase2.write(90);           
              
              
}
 
void loop()
{
  if(Serial1.available()) // check if the esp is sending a message 
  {
 
    
    if(Serial1.find("+IPD,"))
    {
     delay(200); // wait for the serial buffer to fill up (read all the serial data)
     // get the connection id so that we can then disconnect
     int connectionId = Serial1.read()-48; // subtract 48 because the read() function returns 
                                           // the ASCII decimal value and 0 (the first decimal number) starts at 48
  
      // on your browser type http://192.168.4.1/?s=090
      
     Serial1.find("s="); // advance cursor to "pin="

     // get 3 digits 
     serAng = (Serial1.read()-48)*100; // 
     serAng += (Serial1.read()-48)*10; // get first number i.e. if the pin 13 then the 1st number is 1, then multiply to get 10
     serAng += (Serial1.read()-48); // get second number, i.e. if the pin number is 13 then the 2nd number is 3, then add to the first number
     
     //digitalWrite(serAng, !digitalRead(serAng)); // toggle pin    
        // servoBase1.write(serAng); 

     
     // generate web page
     String webpage = String(serAng);
     String cipSend = "AT+CIPSEND=";
     cipSend += connectionId;
     cipSend += ",";
     cipSend +=webpage.length();
     cipSend +="\r\n";
     sendData(cipSend,500,DEBUG);
     delay(20);
     sendData(webpage,500,DEBUG);
     
     // make close command
     String closeCommand = "AT+CIPCLOSE="; 
     closeCommand+=connectionId; // append connection id
     closeCommand+="\r\n";

     sendData(closeCommand,500,DEBUG); // close connection
     
              
    }
  }
        
        
        
       
  
         if (pre_pos<serAng){
                 for(pos = pre_pos; pos <= serAng; pos += 1) // goes from 0 degrees to 180 degrees 
                  {                                  // in steps of 1 degree 
                    servoBase1.write(180-pos); 
                    servoBase2.write(pos);
                    delay(20);                       // waits 15ms for the servo to reach the position 
                  } 
          
         }
         else {
              for(pos = pre_pos; pos>=serAng; pos-=1)     // goes from 180 degrees to 0 degrees 
              {                                
                servoBase1.write(180-pos); 
                servoBase2.write(pos);
                delay(20);   
              } 
         }
        
         
          pre_pos=serAng;
                
              

        
}
 
/*
* Name: sendData
* Description: Function used to send data to ESP8266.
* Params: command - the data/command to send; timeout - the time to wait for a response; debug - print to Serial window?(true = yes, false = no)
* Returns: The response from the esp8266 (if there is a reponse)
*/
String sendData(String command, const int timeout, boolean debug)
{
    String response = "";
    
    Serial1.print(command); // send the read character to the esp8266
    
    long int time = millis();
    
    while( (time+timeout) > millis())
    {
      while(Serial1.available())
      {
        
        // The esp has data so display its output to the serial window 
        char c = Serial1.read(); // read the next character.
        response+=c;
      }  
    }
    
    if(debug)
    {
      Serial.print(response);
    }
    
    return response;
}
